<?php

	// 設定
	$client_id = '' ;			// クライアントID (Client ID)
	$client_secret = '' ;			// クライアントシークレット (Client Secret)
	$callback_uri = '' ;		// コールバックURL (Callback URI)

	// HTML用
	$html = '' ;

	// 実行結果
	$html .= '<h2>実行結果</h2>' ;

	// 「許可」の場合
	if( isset( $_GET['code'] ) && !empty( $_GET['code'] ) && is_string( $_GET['code'] ) )
	{
		// リクエストボディ
		$params = array(
			'client_id' => $client_id ,
			'client_secret' => $client_secret ,
			'redirect_uri' => $callback_uri ,
			'code' => $_GET['code'] ,
			'grant_type' => 'authorization_code' ,
		) ;

		// リクエスト用のコンテキスト
		$context = array(
			'http' => array(
				'method' => 'POST' ,
				'content' => http_build_query( $params ) ,
			)
		) ;

		// cURLでリクエスト
		$curl = curl_init() ;
		curl_setopt( $curl , CURLOPT_URL , 'https://api.bufferapp.com/1/oauth2/token.json' ) ;
		curl_setopt( $curl , CURLOPT_HEADER, 1 ) ; 
		curl_setopt( $curl , CURLOPT_CUSTOMREQUEST , $context['http']['method'] ) ;			// メソッド
		curl_setopt( $curl , CURLOPT_SSL_VERIFYPEER , false ) ;								// 証明書の検証を行わない
		curl_setopt( $curl , CURLOPT_RETURNTRANSFER , true ) ;								// curl_execの結果を文字列で返す
		curl_setopt( $curl , CURLOPT_POSTFIELDS , $context['http']['content'] ) ;			// リクエストボディ
		curl_setopt( $curl , CURLOPT_TIMEOUT , 5 ) ;										// タイムアウトの秒数
		$res1 = curl_exec( $curl ) ;
		$res2 = curl_getinfo( $curl ) ;
		curl_close( $curl ) ;

		// 取得したデータ
		$json = substr( $res1, $res2['header_size'] ) ;										// 取得したデータ(JSONなど)
		$header = substr( $res1, 0, $res2['header_size'] ) ;								// レスポンスヘッダー (検証に利用したい場合にどうぞ)

		// JSONをオブジェクト型に変換する
		$obj = json_decode( $json ) ;

		// エラー判定
		if( !isset( $obj->access_token ) )
		{
			// アクセストークンが取得できなかった
			$error = 'アクセストークンを上手く取得できませんでした…' ;
		}
		else
		{
			// アクセストークンを[$access_token]に代入する
			$access_token = $obj->access_token ;

			// HTMLで出力する
			$html .= '<dl>' ;
			$html .= 	'<dt>アクセストークン</dt>' ;
			$html .= 		'<dd>' . $access_token . '</dd>' ;
			$html .= '</dl>' ;
		}
	}

	// 「拒否」の場合
	elseif( isset( $_GET['error'] ) )
	{
		// 「許可」してくれなかったことに文句を言う
		$error = 'なんで「許可」してくれなかったんですか!?' ;
	}

	// 初回アクセスの場合
	else
	{
		// ユーザーを認証画面に移動させる
		header( 'Location: https://bufferapp.com/oauth2/authorize?client_id=' . $client_id . '&response_type=code&redirect_uri=' . rawurlencode( $callback_uri ) ) ;
	}

	// エラーの場合
	if( isset( $error ) && !empty( $error ) )
	{
		$html = '<p><mark>' . $html . '</mark>もう一度、認証をするには、<a href="' . explode( '?' , $_SERVER['REQUEST_URI'] )[0] . '">こちら</a>をクリックして下さい。</p>' ;
	}

	// 取得したデータ
	$html .= '<h2>取得したデータ</h2>' ;
	$html .= '<p>下記のデータを取得できました。</p>' ;
	$html .= 	'<h3>JSON</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $json . '</textarea></p>' ;
	$html .= 	'<h3>レスポンスヘッダー</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $header . '</textarea></p>' ;

?><!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<meta name="robots" content="noindex,nofollow">

		<!-- ビューポートの設定 -->
		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<title>Buffer APIでOAuth2.0認証をするサンプルデモ</title><!-- 

/********************************************************************************

	SYNCER 〜 知識、感動をみんなと同期(Sync)するブログ

	* 配布場所
	https://syncer.jp/buffer-api-matome

	* 動作確認
	https://syncer.jp/buffer-api-matome/demo/buffer-get-access-token.php

	* 最終更新日時
	2015/08/02 22:11

	* 作者
	あらゆ

	** 連絡先
	Twitter: https://twitter.com/arayutw
	Facebook: https://www.facebook.com/arayutw
	Google+: https://plus.google.com/114918692417332410369/
	E-mail: info@syncer.jp

	※ バグ、不具合の報告、提案、ご要望など、お待ちしております。
	※ 申し訳ありませんが、ご利用者様、個々の環境における問題はサポートしていません。

********************************************************************************/

		-->
	</head>
<body>



<?php echo $html ?>


<p style="text-align:center"><a href="https://syncer.jp/buffer-api-matome">配布元: Syncer</a></p>






</body>
</html>
