<?php

	// アクセストークン
	$access_token = '' ;

	// 設定項目
	$params = array(
		'access_token' => $access_token ,	// アクセストークン
	) ;

	// リクエストURL
	$request_url = 'https://api.bufferapp.com/1/profiles.json' . '?' . http_build_query( $params ) ;

	// cURLでリクエスト
	$curl = curl_init() ;
	curl_setopt( $curl , CURLOPT_URL , $request_url ) ;
	curl_setopt( $curl , CURLOPT_HEADER, 1 ) ; 
	curl_setopt( $curl , CURLOPT_SSL_VERIFYPEER , false ) ;
	curl_setopt( $curl , CURLOPT_RETURNTRANSFER , true ) ;
	curl_setopt( $curl , CURLOPT_TIMEOUT , 5 ) ;
	$res1 = curl_exec( $curl ) ;
	$res2 = curl_getinfo( $curl ) ;
	curl_close( $curl ) ;

	// 取得したデータ
	$json = substr( $res1, $res2['header_size'] ) ;			// 取得したデータ(JSONなど)
	$header = substr( $res1, 0, $res2['header_size'] ) ;		// レスポンスヘッダー (検証に利用したい場合にどうぞ)

	// HTML用
	$html = '' ;

	// JSONデータをオブジェクト形式に変換する
	$obj = json_decode( $json ) ;

	// 実行結果の出力
	$html .= '<h2>実行結果</h2>' ;

	// エラー判定
	if( !$obj )
	{
		$html .= '<p>データを取得できませんでした…。設定を再確認して下さい。</p>' ;
	}
	else
	{
		// インフォメーション
		$html .= '<p>下記のSNSアカウントの情報を取得いたしました。</p>' ;

		// 解析
		foreach( $obj as $item )
		{
			// 各データの整理
			$id = $item->id ;		// SNSのID
			$avatar_https = $item->avatar_https ;		// アバター画像のURL
			$formatted_service = $item->formatted_service ;		// サービス名称
			$service_username = $item->service_username ;		// SNSで使ってるユーザー名

			// ブラウザに出力
			$html .= '<dl>' ;
			$html .= 	'<dt>SNSのID</dt>' ;
			$html .= 		'<dd>' . $id . '</dd>' ;
			$html .= 	'<dt>SNSのサービス名</dt>' ;
			$html .= 		'<dd>' . $formatted_service . '</dd>' ;
			$html .= 	'<dt>SNSのユーザー名</dt>' ;
			$html .= 		'<dd>' . $service_username . '</dd>' ;
			$html .= 	'<dt>アバター画像</dt>' ;
			$html .= 		'<dd><img class="_img" src="' . $avatar_https . '" width="auto" height="50"></dd>' ;

			// スケジュール
			if( isset( $item->schedules ) && !empty( $item->schedules ) )
			{
				// HTML出力
				$html .= 	'<dt>スケジュール</dt>' ;
				$html .= 		'<dd>' ;
				$html .= 			'<dl>' ;

				// 解析
				for( $i=0,$l=count($item->schedules) ; $l>$i ; $i++ )
				{
					// 曜日
					if( isset( $item->schedules[$i]->days ) )
					{
						$html .= '<dt>曜日(' . ( $i + 1 ) . ')</dt>' ;
						$html .= '<dd>' . implode( ',' , $item->schedules[$i]->days ) . '</dd>' ;
					}

					// 時間
					if( isset( $item->schedules[$i]->times ) )
					{
						$html .= '<dt>投稿時間(' . ( $i + 1 ) . ')</dt>' ;
						$html .= '<dd>' . implode( ',' , $item->schedules[$i]->times ) . '</dd>' ;
					}
				}

				$html .= 			'</dl>' ;
				$html .= 		'</dd>' ;
			}

			$html .= '</dl>' ;
		}
	}

	// 取得したデータ
	$html .= '<h2>取得したデータ</h2>' ;
	$html .= '<p>下記のデータを取得できました。</p>' ;
	$html .= 	'<h3>JSON</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $json . '</textarea></p>' ;
	$html .= 	'<h3>レスポンスヘッダー</h3>' ;
	$html .= 	'<p><textarea rows="8">' . $header . '</textarea></p>' ;

	// アプリケーション連携の解除
	$html .= '<h2>アプリケーション連携の解除</h2>' ;
	$html .= '<p>このアプリケーションとの連携は、下記設定ページで解除することができます。</p>' ;
	$html .= '<p><a href="https://buffer.com/app/account/apps" target="_blank">https://buffer.com/app/account/apps</a></p>' ;

?><!DOCTYPE html>
<html>
	<head>
		<meta charset="UTF-8">
		<meta name="robots" content="noindex,nofollow">

		<!-- ビューポートの設定 -->
		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<title>Buffer APIでSNSのアカウント情報を取得するサンプルデモ</title><!-- 

/********************************************************************************

	SYNCER 〜 知識、感動をみんなと同期(Sync)するブログ

	* 配布場所
	https://syncer.jp/buffer-api-matome

	* 動作確認
	https://syncer.jp/buffer-api-matome/demo/get-profiles.php

	* 最終更新日時
	2015/08/02 22:15

	* 作者
	あらゆ

	** 連絡先
	Twitter: https://twitter.com/arayutw
	Facebook: https://www.facebook.com/arayutw
	Google+: https://plus.google.com/114918692417332410369/
	E-mail: info@syncer.jp

	※ バグ、不具合の報告、提案、ご要望など、お待ちしております。
	※ 申し訳ありませんが、ご利用者様、個々の環境における問題はサポートしていません。

********************************************************************************/

		-->
	</head>
<body>



<?php echo $html ?>


<p style="text-align:center"><a href="https://syncer.jp/buffer-api-matome">配布元: Syncer</a></p>






</body>
</html>
